Loading...
Searching...
No Matches
ipid.h File Reference
`#include "misc/options.h"`
`#include "Singular/idrec.h"`
`#include "Singular/subexpr.h"`
`#include "Singular/lists.h"`

Go to the source code of this file.

## Data Structures

struct | ip_command
struct | ip_package
class | proclevel
struct | SModulFunctions
struct | soptionStruct

## Macros

#define | IDROOT (currPack->idroot)
#define | jjNormalizeQRingP(p)
#define | FLAG_STD 0
#define | FLAG_TWOSTD 3
#define | FLAG_QRING 4
#define | FLAG_QRING_DEF 5
#define | FLAG_OTHER_RING 6
#define | FLAG_RING 7
#define | hasFlag(A, F)
#define | setFlag(A, F)
#define | resetFlag(A, F)
#define | IDNEXT(a)
#define | IDTYP(a)
#define | IDFLAG(a)
#define | IDLEV(a)
#define | IDID(a)
#define | IDATTR(a)
#define | IDINT(a)
#define | IDDATA(a)
#define | IDRING(a)
#define | IDINTVEC(a)
#define | IDBIMAT(a)
#define | IDPOLY(a)
#define | IDBIGINT(a)
#define | IDNUMBER(a)
#define | IDIDEAL(a)
#define | IDMATRIX(a)
#define | IDMAP(a)
#define | IDSTRING(a)
#define | IDLIST(a)
#define | IDLINK(a)
#define | IDPACKAGE(a)
#define | IDPROC(a)

## Typedefs

typedef ip_command * | command
typedef int(* | SModulFunc_t) (SModulFunctions *)

## Functions

package | paCopy (package pack)
void | paKill (package pack)
BOOLEAN | load_builtin (const char *newlib, BOOLEAN autoexport, SModulFunc_t init)
void | module_help_main (const char *newlib, const char *help)
void | module_help_proc (const char *newlib, const char *p, const char *help)
idhdl | enterid (const char *a, int lev, int t, idhdl *root, BOOLEAN init=TRUE, BOOLEAN search=TRUE)
idhdl | ggetid (const char *n)
void | killid (const char *a, idhdl *i)
void | killhdl (idhdl h, package prooti=currPack)
void | killhdl2 (idhdl h, idhdl *ih, ring r)
lists | ipNameList (idhdl root)
lists | ipNameListLev (idhdl root, int lev)
void | ipMoveId (idhdl h)
BOOLEAN | checkPackage (package pack)
idhdl | packFindHdl (package r)
poly | jj_NormalizeQRingP (poly p, const ring r)
void | jjNormalizeQRingId (leftv I)
void * | idrecDataInit (int t)
void | ipListFlag (idhdl h)

## Variables

EXTERN_VAR idhdl | currPackHdl
EXTERN_VAR idhdl | basePackHdl
EXTERN_VAR package | currPack
EXTERN_VAR package | basePack
EXTERN_VAR proclevel * | procstack
EXTERN_VAR idhdl | currRingHdl
EXTERN_VAR omBin | sip_command_bin
EXTERN_VAR omBin | sip_package_bin
EXTERN_VAR omBin | idrec_bin
EXTERN_VAR omBin | sleftv_bin
const struct soptionStruct | optionStruct []
const struct soptionStruct | verboseStruct []

## Data Structure Documentation

## sip_command

struct sip_command

Definition at line 25 of file ipid.h.

Data Fields
sleftv | arg1 |
sleftv | arg2 |
sleftv | arg3 |
short | argc |
short | op |

## sip_package

struct sip_package

Definition at line 34 of file ipid.h.

Data Fields
void * | handle |
idhdl | idroot |
language_defs | language |
char * | libname |
BOOLEAN | loaded |
short | ref |

## SModulFunctions

struct SModulFunctions

Definition at line 68 of file ipid.h.

Data Fields
int(*)(const char *libname, const char *procname, BOOLEAN pstatic, BOOLEAN(*func)(leftv res, leftv v)) | iiAddCproc |
int(*)(const char *szName, short nAlias, short nTokval, short nToktype, short nPos) | iiArithAddCmd |

## soptionStruct

struct soptionStruct

Definition at line 148 of file ipid.h.

Data Fields
const char * | name |
unsigned | resetval |
unsigned | setval |

## Macro Definition Documentation

## FLAG_OTHER_RING

#define FLAG_OTHER_RING 6

Definition at line 110 of file ipid.h.

## FLAG_QRING

#define FLAG_QRING 4

Definition at line 108 of file ipid.h.

## FLAG_QRING_DEF

#define FLAG_QRING_DEF 5

Definition at line 109 of file ipid.h.

## FLAG_RING

#define FLAG_RING 7

Definition at line 111 of file ipid.h.

## FLAG_STD

#define FLAG_STD 0

Definition at line 106 of file ipid.h.

## FLAG_TWOSTD

#define FLAG_TWOSTD 3

Definition at line 107 of file ipid.h.

## hasFlag

#define hasFlag | ( |  | A,
|  |  | F )

Value:
Sy_inset((F),(A)->flag)
Sy_inset
#define Sy_inset(x, s)
Definition options.h:33
A
#define A
Definition sirandom.c:24

Definition at line 112 of file ipid.h.

## IDATTR

#define IDATTR | ( |  | a | ) |

Value:
((a)->attribute)

Definition at line 123 of file ipid.h.

## IDBIGINT

#define IDBIGINT | ( |  | a | ) |

Value:
((a)->data.n)

Definition at line 131 of file ipid.h.

## IDBIMAT

#define IDBIMAT | ( |  | a | ) |

Value:
((a)->data.bim)

Definition at line 129 of file ipid.h.

## IDDATA

#define IDDATA | ( |  | a | ) |

Value:
((a)->data.ustring)

Definition at line 126 of file ipid.h.

## IDFLAG

#define IDFLAG | ( |  | a | ) |

Value:
((a)->flag)

Definition at line 120 of file ipid.h.

## IDID

#define IDID | ( |  | a | ) |

Value:
((a)->id)

Definition at line 122 of file ipid.h.

## IDIDEAL

#define IDIDEAL | ( |  | a | ) |

Value:
((a)->data.uideal)

Definition at line 133 of file ipid.h.

## IDINT

#define IDINT | ( |  | a | ) |

Value:
((int)(long)((a)->data.ustring))

Definition at line 125 of file ipid.h.

## IDINTVEC

#define IDINTVEC | ( |  | a | ) |

Value:
((a)->data.iv)

Definition at line 128 of file ipid.h.

## IDLEV

#define IDLEV | ( |  | a | ) |

Value:
((a)->lev)

Definition at line 121 of file ipid.h.

## IDLINK

#define IDLINK | ( |  | a | ) |

Value:
((a)->data.li)

Definition at line 138 of file ipid.h.

## IDLIST

#define IDLIST | ( |  | a | ) |

Value:
((a)->data.l)

Definition at line 137 of file ipid.h.

## IDMAP

#define IDMAP | ( |  | a | ) |

Value:
((a)->data.umap)

Definition at line 135 of file ipid.h.

## IDMATRIX

#define IDMATRIX | ( |  | a | ) |

Value:
((a)->data.umatrix)

Definition at line 134 of file ipid.h.

## IDNEXT

#define IDNEXT | ( |  | a | ) |

Value:
((a)->next)

Definition at line 118 of file ipid.h.

## IDNUMBER

#define IDNUMBER | ( |  | a | ) |

Value:
((a)->data.n)

Definition at line 132 of file ipid.h.

## IDPACKAGE

#define IDPACKAGE | ( |  | a | ) |

Value:
((a)->data.pack)

Definition at line 139 of file ipid.h.

## IDPOLY

#define IDPOLY | ( |  | a | ) |

Value:
((a)->data.p)

Definition at line 130 of file ipid.h.

## IDPROC

#define IDPROC | ( |  | a | ) |

Value:
((a)->data.pinf)

Definition at line 140 of file ipid.h.

## IDRING

#define IDRING | ( |  | a | ) |

Value:
((a)->data.uring)

Definition at line 127 of file ipid.h.

## IDROOT

#define IDROOT (currPack->idroot)

Definition at line 19 of file ipid.h.

## IDSTRING

#define IDSTRING | ( |  | a | ) |

Value:
((a)->data.ustring)

Definition at line 136 of file ipid.h.

## IDTYP

#define IDTYP | ( |  | a | ) |

Value:
((a)->typ)

Definition at line 119 of file ipid.h.

## jjNormalizeQRingP

#define jjNormalizeQRingP | ( |  | p | ) |

Value:
jj_NormalizeQRingP(p,currRing)
p
int p
Definition cfModGcd.cc:4086
jj_NormalizeQRingP
poly jj_NormalizeQRingP(poly p, const ring r)
Definition ipassign.cc:2496
currRing
VAR ring currRing
Widely used global variable which specifies the current polynomial ring for Singular interpreter and ...
Definition polys.cc:13

Definition at line 103 of file ipid.h.

## resetFlag

#define resetFlag | ( |  | A,
|  |  | F )

Value:
(A)->flag&=~Sy_bit(F)
Sy_bit
#define Sy_bit(x)
Definition options.h:31

Definition at line 114 of file ipid.h.

## setFlag

#define setFlag | ( |  | A,
|  |  | F )

Value:
(A)->flag|=Sy_bit(F)

Definition at line 113 of file ipid.h.

## Typedef Documentation

## command

typedef ip_command* command

Definition at line 23 of file ipid.h.

## SModulFunc_t

typedef int(* SModulFunc_t) (SModulFunctions *)

Definition at line 81 of file ipid.h.

## Function Documentation

## checkPackage()

BOOLEAN checkPackage | ( | package | pack | ) |

## enterid()

idhdl enterid | ( | const char * | a,
|  | int | lev,
|  | int | t,
|  | idhdl * | root,
|  | BOOLEAN | init = TRUE,
|  | BOOLEAN | search = TRUE )

Definition at line 279 of file ipid.cc.

{
if (s==NULL) return NULL;
if (root==NULL) return NULL;
idhdl h;
s=omStrDup(s);
// idhdl *save_root=root;
if (t==PACKAGE_CMD)
{
if (root!=&(basePack->idroot))
{
root=&(basePack->idroot);
}
}
// is it already defined in root ?
if ((h=(*root)->get_level(s,lev))!=NULL)
{
if ((IDTYP(h) == t)||(t==DEF_CMD))
{
if (IDTYP(h)==PACKAGE_CMD)
{
if (strcmp(s,"Top")==0)
{
goto errlabel;
}
else return h;
}
else
{
if (BVERBOSE(V_REDEFINE))
{
const char *f=VoiceName();
if (strcmp(f,"STDIN")==0)
Warn("redefining %s (%s)",s,my_yylinebuf);
else
Warn("redefining %s (%s) %s:%d",s,my_yylinebuf,f, yylineno);
}
if (s==IDID(h)) IDID(h)=NULL;
if((t!=PROC_CMD)||(IDPROC(h)->language!=LANG_C))
{
killhdl2(h,root,currRing);
}
}
}
else
goto errlabel;
}
// is it already defined in currRing->idroot ?
else if (search && (currRing!=NULL)&&((*root) != currRing->idroot))
{
if ((h=currRing->idroot->get_level(s,lev))!=NULL)
{
if ((IDTYP(h) == t)||(t==DEF_CMD))
{
if (BVERBOSE(V_REDEFINE))
{
const char *f=VoiceName();
if (strcmp(f,"STDIN")==0)
Warn("redefining %s (%s)",s,my_yylinebuf);
else
Warn("redefining %s (%s) %s:%d",s,my_yylinebuf,f, yylineno);
}
if (s==IDID(h)) IDID(h)=NULL;
// proc is not ring-dep, no need to check for type "proc":
killhdl2(h,&currRing->idroot,currRing);
}
else
goto errlabel;
}
}
// is it already defined in idroot ?
else if (search && (*root != IDROOT))
{
if ((h=IDROOT->get_level(s,lev))!=NULL)
{
if ((IDTYP(h) == t)||(t==DEF_CMD))
{
if (BVERBOSE(V_REDEFINE))
{
const char *f=VoiceName();
if (strcmp(f,"STDIN")==0)
Warn("redefining %s (%s)",s,my_yylinebuf);
else
Warn("redefining %s (%s) %s:%d",s,my_yylinebuf,f, yylineno);
}
if (s==IDID(h)) IDID(h)=NULL;
if((t!=PROC_CMD)||(IDPROC(h)->language!=LANG_C))
{
killhdl2(h,&IDROOT,NULL);
}
}
else
goto errlabel;
}
}
*root = (*root)->set(s, lev, t, init);
#ifndef SING_NDEBUG
checkall();
#endif
return *root;
errlabel:
//Werror("identifier `%s` in use(lev h=%d,typ=%d,t=%d, curr=%d)",s,IDLEV(h),IDTYP(h),t,lev);
Werror("identifier `%s` in use",s);
//listall();
omFreeBinAddr((ADDRESS)s);
return NULL;
}
ADDRESS
void * ADDRESS
Definition auxiliary.h:120
f
FILE * f
Definition checklibs.c:9
idrec::set
idhdl set(const char *s, int lev, int t, BOOLEAN init=TRUE)
Definition ipid.cc:237
Warn
#define Warn
Definition emacs.cc:77
s
const CanonicalForm int s
Definition facAbsFact.cc:51
search
int search(const CFArray &A, const CanonicalForm &F, int i, int j)
search for F in A between index i and j
Definition facSparseHensel.h:566
yylineno
VAR int yylineno
Definition febase.cc:40
my_yylinebuf
VAR char my_yylinebuf[80]
Definition febase.cc:44
VoiceName
const char * VoiceName()
Definition fevoices.cc:58
PROC_CMD
@ PROC_CMD
Definition grammar.cc:281
killhdl2
void killhdl2(idhdl h, idhdl *ih, ring r)
Definition ipid.cc:445
basePack
VAR package basePack
Definition ipid.cc:56
IDPROC
#define IDPROC(a)
Definition ipid.h:140
IDID
#define IDID(a)
Definition ipid.h:122
IDROOT
#define IDROOT
Definition ipid.h:19
IDTYP
#define IDTYP(a)
Definition ipid.h:119
h
STATIC_VAR Poly * h
Definition janet.cc:971
omStrDup
#define omStrDup(s)
Definition omAllocDecl.h:263
omFreeBinAddr
#define omFreeBinAddr(addr)
Definition omAllocDecl.h:258
NULL
#define NULL
Definition omList.c:12
BVERBOSE
#define BVERBOSE(a)
Definition options.h:35
V_REDEFINE
#define V_REDEFINE
Definition options.h:45
Werror
void Werror(const char *fmt,...)
Definition reporter.cc:189
idhdl
idrec * idhdl
Definition ring.h:22
LANG_C
@ LANG_C
Definition subexpr.h:22
PACKAGE_CMD
@ PACKAGE_CMD
Definition tok.h:150
DEF_CMD
@ DEF_CMD
Definition tok.h:58

## ggetid()

idhdl ggetid | ( | const char * | n | ) |

Definition at line 581 of file ipid.cc.

{
if (currRing!=NULL)
{
idhdl h2 = currRing->idroot->get(n,myynest);
if ((h2!=NULL)&&(IDLEV(h2)==myynest)) return h2;
idhdl h = IDROOT->get(n,myynest);
if (h!=NULL) return h;
if (h2!=NULL) return h2;
}
else
{
idhdl h = IDROOT->get(n,myynest);
if (h!=NULL) return h;
}
if (basePack!=currPack)
return basePack->idroot->get(n,myynest);
return NULL;
}
myynest
VAR int myynest
Definition febase.cc:41
currPack
VAR package currPack
Definition ipid.cc:55
IDLEV
#define IDLEV(a)
Definition ipid.h:121

## idrecDataInit()

void * idrecDataInit | ( | int | t | ) |

Definition at line 138 of file ipid.cc.

{
switch (t)
{
//the type with init routines:
#ifdef SINGULAR_4_2
case CNUMBER_CMD:
return (void*)n2Init(0,NULL);
case CPOLY_CMD:
return (void*)p2Init(0,NULL);
case CMATRIX_CMD:
#endif
case BIGINTMAT_CMD:
return (void *)new bigintmat();
case BIGINTVEC_CMD:
return (void *)new bigintmat(1,0,coeffs_BIGINT);
case BUCKET_CMD:
if (currRing!=NULL)
return (void*)sBucketCreate(currRing);
else
{
WerrorS("need basering for polyBucket");
return NULL;
}
case INTVEC_CMD:
case INTMAT_CMD:
return (void *)new intvec();
case NUMBER_CMD:
{
if (currRing!=NULL) return (void *) nInit(0);
else return NULL;
}
case BIGINT_CMD:
return (void *) n_Init(0, coeffs_BIGINT);
case IDEAL_CMD:
case MODUL_CMD:
case MATRIX_CMD:
case SMATRIX_CMD:
return (void*) idInit(1,1);
case MAP_CMD:
{
map m = (map)idInit(1,1);
m->preimage = omStrDup(IDID(currRingHdl));
return (void *)m;
}
case STRING_CMD:
return (void *)omAlloc0(1);
case LIST_CMD:
{
lists l=(lists)omAllocBin(slists_bin);
l->Init();
return (void*)l;
}
//the types with the standard init: set the struct to zero
case LINK_CMD:
return (void*) omAlloc0Bin(sip_link_bin);
case PACKAGE_CMD:
{
package pa=(package)omAlloc0Bin(sip_package_bin);
pa->language=LANG_NONE;
pa->loaded = FALSE;
return (void*)pa;
}
case PROC_CMD:
{
procinfov pi=(procinfov)omAlloc0Bin(procinfo_bin);
pi->ref=1;
pi->language=LANG_NONE;
return (void*)pi;
}
case RESOLUTION_CMD:
return (void *)omAlloc0(sizeof(ssyStrategy));
//other types: without alloc. (int,script,poly,def,package,..)
case INT_CMD:
case DEF_CMD:
case POLY_CMD:
case VECTOR_CMD:
case RING_CMD:
case CRING_CMD:
case QRING_CMD:
return NULL;
default:
{
if (t>MAX_TOK)
{
#ifdef BLACKBOX_DEVEL
Print("bb-type %d\n",t);
#endif
blackbox *bb=getBlackboxStuff(t);
if (bb!=NULL)
return (void *)bb->blackbox_Init(bb);
}
else
Werror("unknown type in idrecDataInit:%d",t);
break;
}
}
return (void *)0L;
}
FALSE
#define FALSE
Definition auxiliary.h:97
getBlackboxStuff
blackbox * getBlackboxStuff(const int t)
return the structure to the type given by t
Definition blackbox.cc:17
l
int l
Definition cfEzgcd.cc:100
m
int m
Definition cfEzgcd.cc:128
map
CanonicalForm map(const CanonicalForm &primElem, const Variable &alpha, const CanonicalForm &F, const Variable &beta)
map from to such that is mapped onto
Definition cf_map_ext.cc:505
bigintmat
Matrices of numbers.
Definition bigintmat.h:51
intvec
Definition intvec.h:24
n_Init
static FORCE_INLINE number n_Init(long i, const coeffs r)
a number representing i in the given coeff field/ring r
Definition coeffs.h:541
pa
static BOOLEAN pa(leftv res, leftv args)
Definition cohomo.cc:3770
Print
#define Print
Definition emacs.cc:80
WerrorS
void WerrorS(const char *s)
Definition feFopen.cc:24
IDEAL_CMD
@ IDEAL_CMD
Definition grammar.cc:285
MATRIX_CMD
@ MATRIX_CMD
Definition grammar.cc:287
BUCKET_CMD
@ BUCKET_CMD
Definition grammar.cc:284
BIGINTMAT_CMD
@ BIGINTMAT_CMD
Definition grammar.cc:278
MAP_CMD
@ MAP_CMD
Definition grammar.cc:286
INTMAT_CMD
@ INTMAT_CMD
Definition grammar.cc:280
MODUL_CMD
@ MODUL_CMD
Definition grammar.cc:288
SMATRIX_CMD
@ SMATRIX_CMD
Definition grammar.cc:292
VECTOR_CMD
@ VECTOR_CMD
Definition grammar.cc:293
RESOLUTION_CMD
@ RESOLUTION_CMD
Definition grammar.cc:291
BIGINTVEC_CMD
@ BIGINTVEC_CMD
Definition grammar.cc:279
NUMBER_CMD
@ NUMBER_CMD
Definition grammar.cc:289
POLY_CMD
@ POLY_CMD
Definition grammar.cc:290
RING_CMD
@ RING_CMD
Definition grammar.cc:282
currRingHdl
VAR idhdl currRingHdl
Definition ipid.cc:57
pi
#define pi
Definition libparse.cc:1145
slists_bin
VAR omBin slists_bin
Definition lists.cc:23
lists
slists * lists
Definition mpr_numeric.h:146
nInit
#define nInit(i)
Definition numbers.h:24
omAllocBin
#define omAllocBin(bin)
Definition omAllocDecl.h:205
omAlloc0Bin
#define omAlloc0Bin(bin)
Definition omAllocDecl.h:206
omAlloc0
#define omAlloc0(size)
Definition omAllocDecl.h:211
coeffs_BIGINT
VAR coeffs coeffs_BIGINT
Definition polys.cc:14
sBucketCreate
sBucket_pt sBucketCreate(const ring r)
Definition sbuckets.cc:96
sip_link_bin
VAR omBin sip_link_bin
Definition silink.cc:40
idInit
ideal idInit(int idsize, int rank)
initialise an ideal / module
Definition simpleideals.cc:35
procinfov
procinfo * procinfov
Definition structs.h:56
procinfo_bin
VAR omBin procinfo_bin
Definition subexpr.cc:42
LANG_NONE
@ LANG_NONE
Definition subexpr.h:22
ssyStrategy
Definition syz.h:37
BIGINT_CMD
@ BIGINT_CMD
Definition tok.h:38
CRING_CMD
@ CRING_CMD
Definition tok.h:56
LIST_CMD
@ LIST_CMD
Definition tok.h:118
INTVEC_CMD
@ INTVEC_CMD
Definition tok.h:101
CMATRIX_CMD
@ CMATRIX_CMD
Definition tok.h:46
CNUMBER_CMD
@ CNUMBER_CMD
Definition tok.h:47
LINK_CMD
@ LINK_CMD
Definition tok.h:117
QRING_CMD
@ QRING_CMD
Definition tok.h:160
STRING_CMD
@ STRING_CMD
Definition tok.h:187
CPOLY_CMD
@ CPOLY_CMD
Definition tok.h:48
INT_CMD
@ INT_CMD
Definition tok.h:96
MAX_TOK
@ MAX_TOK
Definition tok.h:220

## ipListFlag()

void ipListFlag | ( | idhdl | h | ) |

Definition at line 619 of file ipid.cc.

{
if (hasFlag(h,FLAG_STD)) PrintS(" (SB)");
#ifdef HAVE_PLURAL
if (hasFlag(h,FLAG_TWOSTD)) PrintS(" (2SB)");
#endif
}
hasFlag
#define hasFlag(A, F)
Definition ipid.h:112
FLAG_TWOSTD
#define FLAG_TWOSTD
Definition ipid.h:107
FLAG_STD
#define FLAG_STD
Definition ipid.h:106
PrintS
void PrintS(const char *s)
Definition reporter.cc:288

## ipMoveId()

void ipMoveId | ( | idhdl | h | ) |

Definition at line 704 of file ipid.cc.

{
if ((currRing!=NULL)&&(tomove!=NULL))
{
if (RingDependend(IDTYP(tomove))
|| ((IDTYP(tomove)==LIST_CMD) && (lRingDependend(IDLIST(tomove)))))
{
/*move 'tomove' to ring id's*/
if (ipSwapId(tomove,IDROOT,currRing->idroot))
ipSwapId(tomove,basePack->idroot,currRing->idroot);
}
else
{
/*move 'tomove' to global id's*/
ipSwapId(tomove,currRing->idroot,IDROOT);
}
}
}
RingDependend
static int RingDependend(int t)
Definition gentable.cc:23
ipSwapId
static int ipSwapId(idhdl tomove, idhdl &root1, idhdl &root2)
Definition ipid.cc:679
IDLIST
#define IDLIST(a)
Definition ipid.h:137
lRingDependend
BOOLEAN lRingDependend(lists L)
Definition lists.cc:222

## ipNameList()

lists ipNameList | ( | idhdl | root | ) |

Definition at line 627 of file ipid.cc.

{
idhdl h=root;
/* compute the length */
int l=0;
while (h!=NULL) { l++; h=IDNEXT(h); }
/* allocate list */
lists L=(lists)omAllocBin(slists_bin);
L->Init(l);
/* copy names */
h=root;
l=0;
while (h!=NULL)
{
/* list is initialized with 0 => no need to clear anything */
L->m[l].rtyp=STRING_CMD;
L->m[l].data=omStrDup(IDID(h));
l++;
h=IDNEXT(h);
}
return L;
}
sleftv::rtyp
int rtyp
Definition subexpr.h:91
sleftv::data
void * data
Definition subexpr.h:88
slists::m
sleftv * m
Definition lists.h:46
slists::Init
INLINE_THIS void Init(int l=0)
IDNEXT
#define IDNEXT(a)
Definition ipid.h:118

## ipNameListLev()

lists ipNameListLev | ( | idhdl | root,
|  | int | lev )

Definition at line 650 of file ipid.cc.

{
idhdl h=root;
/* compute the length */
int l=0;
while (h!=NULL) { if (IDLEV(h)==lev) l++; h=IDNEXT(h); }
/* allocate list */
lists L=(lists)omAllocBin(slists_bin);
L->Init(l);
/* copy names */
h=root;
l=0;
while (h!=NULL)
{
if (IDLEV(h)==lev)
{
/* list is initialized with 0 => no need to clear anything */
L->m[l].rtyp=STRING_CMD;
L->m[l].data=omStrDup(IDID(h));
l++;
}
h=IDNEXT(h);
}
return L;
}

## jj_NormalizeQRingP()

poly jj_NormalizeQRingP | ( | poly | p,
|  | const ring | r )

Definition at line 2496 of file ipassign.cc.

{
if((p!=NULL) && (r->qideal!=NULL))
{
ring save=currRing;
if (r!=currRing) rChangeCurrRing(r);
ideal F=idInit(1,1);
poly p2=kNF(F,r->qideal,p);
p_Normalize(p2,r);
id_Delete(&F,r);
p_Delete(&p,r);
p=p2;
if (r!=save) rChangeCurrRing(save);
}
return p;
}
kNF
poly kNF(ideal F, ideal Q, poly p, int syzComp, int lazyReduce)
Definition kstd1.cc:3229
p_Normalize
void p_Normalize(poly p, const ring r)
Definition p_polys.cc:3939
p_Delete
static void p_Delete(poly *p, const ring r)
Definition p_polys.h:903
rChangeCurrRing
void rChangeCurrRing(ring r)
Definition polys.cc:16
id_Delete
void id_Delete(ideal *h, ring r)
deletes an ideal/module/matrix
Definition simpleideals.cc:123

## jjNormalizeQRingId()

void jjNormalizeQRingId | ( | leftv | I | ) |

Definition at line 2461 of file ipassign.cc.

{
assume ((currRing->qideal!=NULL) && (!hasFlag(I,FLAG_QRING)));
{
if (I->e==NULL)
{
ideal I0=(ideal)I->Data();
switch (I->Typ())
{
case IDEAL_CMD:
case MODUL_CMD:
{
ideal F=idInit(1,1);
ideal II=kNF(F,currRing->qideal,I0);
idDelete(&F);
if (I->rtyp!=IDHDL)
{
idDelete((ideal*)&(I0));
I->data=II;
}
else
{
idhdl h=(idhdl)I->data;
idDelete((ideal*)&IDIDEAL(h));
IDIDEAL(h)=II;
setFlag(h,FLAG_QRING);
}
break;
}
default: break;
}
setFlag(I,FLAG_QRING);
}
}
}
sleftv::Typ
int Typ()
Definition subexpr.cc:1048
sleftv::Data
void * Data()
Definition subexpr.cc:1192
sleftv::e
Subexpr e
Definition subexpr.h:105
idDelete
#define idDelete(H)
delete an ideal
Definition ideals.h:29
setFlag
#define setFlag(A, F)
Definition ipid.h:113
IDIDEAL
#define IDIDEAL(a)
Definition ipid.h:133
FLAG_QRING
#define FLAG_QRING
Definition ipid.h:108
assume
#define assume(x)
Definition mod2.h:389
IDHDL
#define IDHDL
Definition tok.h:31

## killhdl()

void killhdl | ( | idhdl | h,
|  | package | prooti = currPack )

Definition at line 414 of file ipid.cc.

{
int t=IDTYP(h);
if (((BEGIN_RING<t) && (t<END_RING))
|| ((t==LIST_CMD) && (lRingDependend((lists)IDDATA(h)))))
killhdl2(h,&currRing->idroot,currRing);
else
{
if(t==PACKAGE_CMD)
{
killhdl2(h,&(basePack->idroot),NULL);
}
else
{
idhdl s=proot->idroot;
while ((s!=h) && (s!=NULL)) s=s->next;
if (s!=NULL)
killhdl2(h,&(proot->idroot),NULL);
else if (basePack!=proot)
{
idhdl s=basePack->idroot;
while ((s!=h) && (s!=NULL)) s=s->next;
if (s!=NULL)
killhdl2(h,&(basePack->idroot),currRing);
else
killhdl2(h,&(currRing->idroot),currRing);
}
}
}
}
END_RING
@ END_RING
Definition grammar.cc:311
BEGIN_RING
@ BEGIN_RING
Definition grammar.cc:283
IDDATA
#define IDDATA(a)
Definition ipid.h:126

## killhdl2()

void killhdl2 | ( | idhdl | h,
|  | idhdl * | ih,
|  | ring | r )

Definition at line 445 of file ipid.cc.

{
//printf("kill %s, id %x, typ %d lev: %d\n",IDID(h),(int)IDID(h),IDTYP(h),IDLEV(h));
idhdl hh;
if (TEST_V_ALLWARN
&& (IDLEV(h)!=myynest)
&&(IDLEV(h)==0))
{
if (((*ih)==basePack->idroot)
|| ((currRing!=NULL)&&((*ih)==currRing->idroot)))
Warn("kill global `%s` at line >>%s<<\n",IDID(h),my_yylinebuf);
}
if ((IDTYP(h)!=PROC_CMD) && (h->attribute!=NULL))
{
if ((IDTYP(h)==RING_CMD)&&(IDRING(h)!=r))
h->attribute->killAll(IDRING(h));
else
h->attribute->killAll(r);
h->attribute=NULL;
}
if (IDTYP(h) == PACKAGE_CMD)
{
if ((((IDPACKAGE(h)->language==LANG_C) ||(IDPACKAGE(h)->language==LANG_MIX))
&&(IDPACKAGE(h)->idroot!=NULL))
|| (strcmp(IDID(h),"Top")==0))
{
Warn("cannot kill `%s`",IDID(h));
return;
}
// any objects defined for this package ?
if ((IDPACKAGE(h)->ref<=0) && (IDPACKAGE(h)->idroot!=NULL))
{
if (currPack==IDPACKAGE(h))
{
currPack=basePack;
currPackHdl=NULL;
}
idhdl * hd = &IDRING(h)->idroot;
idhdl hdh = IDNEXT(*hd);
idhdl temp;
while (hdh!=NULL)
{
temp = IDNEXT(hdh);
killhdl2(hdh,&(IDPACKAGE(h)->idroot),NULL);
hdh = temp;
}
killhdl2(*hd,hd,NULL);
if (IDPACKAGE(h)->libname!=NULL) omFreeBinAddr((ADDRESS)(IDPACKAGE(h)->libname));
}
paKill(IDPACKAGE(h));
if (currPackHdl==h) currPackHdl=packFindHdl(currPack);
iiCheckPack(currPack);
}
else if (IDTYP(h)==RING_CMD)
rKill(h);
else if (IDDATA(h)!=NULL)
s_internalDelete(IDTYP(h),IDDATA(h),r);
IDDATA(h)=NULL;
// general -------------------------------------------------------------
// now dechain it and delete idrec
if (IDID(h)!=NULL) // OB: ?????
omFreeBinAddr((ADDRESS)IDID(h));
IDID(h)=NULL;
IDDATA(h)=NULL;
if (h == (*ih))
{
// h is at the beginning of the list
*ih = IDNEXT(h) /* ==*ih */;
}
else if (ih!=NULL)
{
// h is somethere in the list:
hh = *ih;
loop
{
if (hh==NULL)
{
PrintS(">>?<< not found for kill\n");
return;
}
idhdl hhh = IDNEXT(hh);
if (hhh == h)
{
IDNEXT(hh) = IDNEXT(hhh);
break;
}
hh = hhh;
}
}
omFreeBin((ADDRESS)h, idrec_bin);
}
idrec_bin
VAR omBin idrec_bin
Definition ipid.cc:48
currPackHdl
VAR idhdl currPackHdl
Definition ipid.cc:53
packFindHdl
idhdl packFindHdl(package r)
Definition ipid.cc:828
IDPACKAGE
#define IDPACKAGE(a)
Definition ipid.h:139
paKill
void paKill(package pack)
Definition ipid.h:50
IDRING
#define IDRING(a)
Definition ipid.h:127
iiCheckPack
void iiCheckPack(package &p)
Definition ipshell.cc:1631
rKill
void rKill(ring r)
Definition ipshell.cc:6181
omFreeBin
#define omFreeBin(addr, bin)
Definition omAllocDecl.h:259
TEST_V_ALLWARN
#define TEST_V_ALLWARN
Definition options.h:145
loop
#define loop
Definition structs.h:71
s_internalDelete
void s_internalDelete(const int t, void *d, const ring r)
Definition subexpr.cc:518
LANG_MIX
@ LANG_MIX
Definition subexpr.h:22

## killid()

void killid | ( | const char * | a,
|  | idhdl * | i )

Definition at line 387 of file ipid.cc.

{
if (id!=NULL)
{
idhdl h = (*ih)->get(id,myynest);
// id not found in global list, is it defined in current ring ?
if (h==NULL)
{
if ((currRing!=NULL) && (*ih != (currRing->idroot)))
{
h = currRing->idroot->get(id,myynest);
if (h!=NULL)
{
killhdl2(h,&(currRing->idroot),currRing);
return;
}
}
Werror("`%s` is not defined",id);
return;
}
killhdl2(h,ih,currRing);
}
else
WerrorS("kill what ?");
}

## load_builtin()

BOOLEAN load_builtin | ( | const char * | newlib,
|  | BOOLEAN | autoexport,
|  | SModulFunc_t | init )

Definition at line 1304 of file iplib.cc.

{
int iiAddCproc(const char *libname, const char *procname, BOOLEAN pstatic,
BOOLEAN(*func)(leftv res, leftv v));
/*
typedef int (*fktn_t)(int(*iiAddCproc)(const char *libname, const char *procname,
BOOLEAN pstatic,
BOOLEAN(*func)(leftv res, leftv v)));
*/
// SModulFunc_t fktn;
idhdl pl;
char *plib = iiConvName(newlib);
// BOOLEAN RET=TRUE;
// int token;
pl = basePack->idroot->get(plib,0); // search PACKAGE only in Top
if ((pl!=NULL)
&&(IDTYP(pl)==PACKAGE_CMD))
{
if(IDPACKAGE(pl)->language==LANG_C)
{
if (BVERBOSE(V_LOAD_LIB)) Warn( "(builtin) %s already loaded", newlib);
omFreeBinAddr(plib);
return FALSE;
}
}
else
{
pl = enterid( plib,0, PACKAGE_CMD, &IDROOT, TRUE );
IDPACKAGE(pl)->libname=omStrDup(newlib);
}
omFreeBinAddr(plib);
IDPACKAGE(pl)->language = LANG_C;
IDPACKAGE(pl)->handle=(void *)NULL;
SModulFunctions sModulFunctions;
package s=currPack;
currPack=IDPACKAGE(pl);
if( init!= NULL)
{
sModulFunctions.iiArithAddCmd = iiArithAddCmd;
if (autoexport) sModulFunctions.iiAddCproc = iiAddCprocTop;
else sModulFunctions.iiAddCproc = iiAddCproc;
(*init)(&sModulFunctions);
}
if (BVERBOSE(V_LOAD_LIB)) Print( "// ** loaded (builtin) %s \n", newlib);
currPack->loaded=1;
currPack=s;
return FALSE;
}
BOOLEAN
int BOOLEAN
Definition auxiliary.h:88
TRUE
#define TRUE
Definition auxiliary.h:101
res
CanonicalForm res
Definition facAbsFact.cc:60
v
const Variable & v
< [in] a sqrfree bivariate poly
Definition facBivar.h:39
iiArithAddCmd
int iiArithAddCmd(const char *szName, short nAlias, short nTokval, short nToktype, short nPos=-1)
Definition iparith.cc:10118
enterid
idhdl enterid(const char *s, int lev, int t, idhdl *root, BOOLEAN init, BOOLEAN search)
Definition ipid.cc:279
SModulFunctions::iiArithAddCmd
int(* iiArithAddCmd)(const char *szName, short nAlias, short nTokval, short nToktype, short nPos)
Definition ipid.h:72
SModulFunctions::iiAddCproc
int(* iiAddCproc)(const char *libname, const char *procname, BOOLEAN pstatic, BOOLEAN(*func)(leftv res, leftv v))
Definition ipid.h:70
SModulFunctions
Definition ipid.h:69
iiAddCproc
int iiAddCproc(const char *libname, const char *procname, BOOLEAN pstatic, BOOLEAN(*func)(leftv res, leftv v))
Definition iplib.cc:1073
iiConvName
char * iiConvName(const char *libname)
Definition iplib.cc:1439
iiAddCprocTop
int iiAddCprocTop(const char *libname, const char *procname, BOOLEAN pstatic, BOOLEAN(*func)(leftv res, leftv v))
Definition iplib.cc:1148
V_LOAD_LIB
#define V_LOAD_LIB
Definition options.h:47
leftv
sleftv * leftv
Definition structs.h:53

## module_help_main()

void module_help_main | ( | const char * | newlib,
|  | const char * | help )

Definition at line 1357 of file iplib.cc.

{
char *plib = iiConvName(newlib);
idhdl pl = basePack->idroot->get(plib,0);
if ((pl==NULL)||(IDTYP(pl)!=PACKAGE_CMD))
Werror(">>%s<< is not a package (trying to add package help)",plib);
else
{
package s=currPack;
currPack=IDPACKAGE(pl);
idhdl h=enterid("info",0,STRING_CMD,&IDROOT,FALSE);
IDSTRING(h)=omStrDup(help);
currPack=s;
}
}
IDSTRING
#define IDSTRING(a)
Definition ipid.h:136
help
#define help
Definition libparse.cc:1230

## module_help_proc()

void module_help_proc | ( | const char * | newlib,
|  | const char * | p,
|  | const char * | help )

Definition at line 1372 of file iplib.cc.

{
char *plib = iiConvName(newlib);
idhdl pl = basePack->idroot->get(plib,0);
if ((pl==NULL)||(IDTYP(pl)!=PACKAGE_CMD))
Werror(">>%s<< is not a package(trying to add help for %s)",plib,p);
else
{
package s=currPack;
currPack=IDPACKAGE(pl);
char buff[SINGULAR_PATH_LENGTH];
buff[SINGULAR_PATH_LENGTH-1]='\0';
strncpy(buff,p,SINGULAR_PATH_LENGTH-1);
strncat(buff,"_help",SINGULAR_PATH_LENGTH-1-strlen(p));
idhdl h=enterid(buff,0,STRING_CMD,&IDROOT,FALSE);
IDSTRING(h)=omStrDup(help);
currPack=s;
}
}
SINGULAR_PATH_LENGTH
#define SINGULAR_PATH_LENGTH
Definition iplib.cc:21

## packFindHdl()

idhdl packFindHdl | ( | package | r | ) |

Definition at line 828 of file ipid.cc.

{
idhdl h=basePack->idroot;
while (h!=NULL)
{
if ((IDTYP(h)==PACKAGE_CMD)
&& (IDPACKAGE(h)==r))
return h;
h=IDNEXT(h);
}
return NULL;
}

## paCopy()

package paCopy | ( | package | pack | ) |

inline

Definition at line 44 of file ipid.h.

{
pack->ref++;
return pack;
}

## paKill()

void paKill | ( | package | pack | ) |

inline

Definition at line 50 of file ipid.h.

{
pack->ref--;
}

## Variable Documentation

## basePack

EXTERN_VAR package basePack

Definition at line 18 of file ipid.h.

## basePackHdl

EXTERN_VAR idhdl basePackHdl

Definition at line 16 of file ipid.h.

## currPack

EXTERN_VAR package currPack

Definition at line 17 of file ipid.h.

## currPackHdl

EXTERN_VAR idhdl currPackHdl

Definition at line 15 of file ipid.h.

## currRingHdl

EXTERN_VAR idhdl currRingHdl

Definition at line 78 of file ipid.h.

## idrec_bin

EXTERN_VAR omBin idrec_bin

Definition at line 144 of file ipid.h.

## optionStruct

const struct soptionStruct optionStruct[]

extern

Definition at line 508 of file misc_ip.cc.

{
{"prot", Sy_bit(OPT_PROT), ~Sy_bit(OPT_PROT) },
{"redSB", Sy_bit(OPT_REDSB), ~Sy_bit(OPT_REDSB) },
{"notBuckets", Sy_bit(OPT_NOT_BUCKETS), ~Sy_bit(OPT_NOT_BUCKETS) },
{"notSugar", Sy_bit(OPT_NOT_SUGAR), ~Sy_bit(OPT_NOT_SUGAR) },
{"interrupt", Sy_bit(OPT_INTERRUPT), ~Sy_bit(OPT_INTERRUPT) },
{"sugarCrit", Sy_bit(OPT_SUGARCRIT), ~Sy_bit(OPT_SUGARCRIT) },
{"teach", Sy_bit(OPT_DEBUG), ~Sy_bit(OPT_DEBUG) },
{"notSyzMinim", Sy_bit(OPT_NO_SYZ_MINIM), ~Sy_bit(OPT_NO_SYZ_MINIM) },
/* 9 return SB in syz, quotient, intersect, modulo */
{"returnSB", Sy_bit(OPT_RETURN_SB), ~Sy_bit(OPT_RETURN_SB) },
{"fastHC", Sy_bit(OPT_FASTHC), ~Sy_bit(OPT_FASTHC) },
/* 11-19 sort in L/T */
{"staircaseBound",Sy_bit(OPT_STAIRCASEBOUND),~Sy_bit(OPT_STAIRCASEBOUND) },
{"multBound", Sy_bit(OPT_MULTBOUND), ~Sy_bit(OPT_MULTBOUND) },
{"degBound", Sy_bit(OPT_DEGBOUND), ~Sy_bit(OPT_DEGBOUND) },
{"redTailSyz", Sy_bit(OPT_REDTAIL_SYZ), ~Sy_bit(OPT_REDTAIL_SYZ) },
/* 25 no redTail(p)/redTail(s) */
{"redTail", Sy_bit(OPT_REDTAIL), ~Sy_bit(OPT_REDTAIL) },
{"redThrough", Sy_bit(OPT_REDTHROUGH), ~Sy_bit(OPT_REDTHROUGH) },
{"lazy", Sy_bit(OPT_OLDSTD), ~Sy_bit(OPT_OLDSTD) },
{"intStrategy", Sy_bit(OPT_INTSTRATEGY), ~Sy_bit(OPT_INTSTRATEGY) },
{"infRedTail", Sy_bit(OPT_INFREDTAIL), ~Sy_bit(OPT_INFREDTAIL) },
/* 30: use not regularity for syz */
{"notRegularity",Sy_bit(OPT_NOTREGULARITY), ~Sy_bit(OPT_NOTREGULARITY) },
{"weightM", Sy_bit(OPT_WEIGHTM), ~Sy_bit(OPT_WEIGHTM) },
/*special for "none" and also end marker for showOption:*/
{"ne", 0, 0 }
};
OPT_SUGARCRIT
#define OPT_SUGARCRIT
Definition options.h:81
OPT_PROT
#define OPT_PROT
Definition options.h:76
OPT_INFREDTAIL
#define OPT_INFREDTAIL
Definition options.h:95
OPT_INTSTRATEGY
#define OPT_INTSTRATEGY
Definition options.h:93
OPT_WEIGHTM
#define OPT_WEIGHTM
Definition options.h:98
OPT_REDTAIL_SYZ
#define OPT_REDTAIL_SYZ
Definition options.h:88
OPT_REDTAIL
#define OPT_REDTAIL
Definition options.h:92
OPT_RETURN_SB
#define OPT_RETURN_SB
Definition options.h:85
OPT_NOT_SUGAR
#define OPT_NOT_SUGAR
Definition options.h:79
OPT_REDTHROUGH
#define OPT_REDTHROUGH
Definition options.h:83
OPT_REDSB
#define OPT_REDSB
Definition options.h:77
OPT_NOTREGULARITY
#define OPT_NOTREGULARITY
Definition options.h:97
OPT_DEBUG
#define OPT_DEBUG
Definition options.h:82
OPT_MULTBOUND
#define OPT_MULTBOUND
Definition options.h:90
OPT_STAIRCASEBOUND
#define OPT_STAIRCASEBOUND
Definition options.h:89
OPT_INTERRUPT
#define OPT_INTERRUPT
Definition options.h:80
OPT_DEGBOUND
#define OPT_DEGBOUND
Definition options.h:91
OPT_NOT_BUCKETS
#define OPT_NOT_BUCKETS
Definition options.h:78
OPT_FASTHC
#define OPT_FASTHC
Definition options.h:86
OPT_OLDSTD
#define OPT_OLDSTD
Definition options.h:87
OPT_NO_SYZ_MINIM
#define OPT_NO_SYZ_MINIM
Definition options.h:84

## procstack

EXTERN_VAR proclevel* procstack

Definition at line 66 of file ipid.h.

## sip_command_bin

EXTERN_VAR omBin sip_command_bin

Definition at line 142 of file ipid.h.

## sip_package_bin

EXTERN_VAR omBin sip_package_bin

Definition at line 143 of file ipid.h.

## sleftv_bin

EXTERN_VAR omBin sleftv_bin

Definition at line 145 of file ipid.h.

## verboseStruct

const struct soptionStruct verboseStruct[]

extern

Definition at line 539 of file misc_ip.cc.

{
{"assign_none",Sy_bit(V_ASSIGN_NONE),~Sy_bit(V_ASSIGN_NONE)},
{"mem", Sy_bit(V_SHOW_MEM), ~Sy_bit(V_SHOW_MEM) },
{"yacc", Sy_bit(V_YACC), ~Sy_bit(V_YACC) },
{"redefine", Sy_bit(V_REDEFINE), ~Sy_bit(V_REDEFINE) },
{"reading", Sy_bit(V_READING), ~Sy_bit(V_READING) },
{"loadLib", Sy_bit(V_LOAD_LIB), ~Sy_bit(V_LOAD_LIB) },
{"debugLib", Sy_bit(V_DEBUG_LIB), ~Sy_bit(V_DEBUG_LIB) },
{"loadProc", Sy_bit(V_LOAD_PROC), ~Sy_bit(V_LOAD_PROC) },
{"defRes", Sy_bit(V_DEF_RES), ~Sy_bit(V_DEF_RES) },
{"usage", Sy_bit(V_SHOW_USE), ~Sy_bit(V_SHOW_USE) },
{"Imap", Sy_bit(V_IMAP), ~Sy_bit(V_IMAP) },
{"prompt", Sy_bit(V_PROMPT), ~Sy_bit(V_PROMPT) },
{"length", Sy_bit(V_LENGTH), ~Sy_bit(V_LENGTH) },
{"notWarnSB",Sy_bit(V_NSB), ~Sy_bit(V_NSB) },
{"contentSB",Sy_bit(V_CONTENTSB), ~Sy_bit(V_CONTENTSB) },
{"cancelunit",Sy_bit(V_CANCELUNIT),~Sy_bit(V_CANCELUNIT)},
{"modpsolve",Sy_bit(V_MODPSOLVSB),~Sy_bit(V_MODPSOLVSB)},
{"geometricSB",Sy_bit(V_UPTORADICAL),~Sy_bit(V_UPTORADICAL)},
{"findMonomials",Sy_bit(V_FINDMONOM),~Sy_bit(V_FINDMONOM)},
{"coefStrat",Sy_bit(V_COEFSTRAT), ~Sy_bit(V_COEFSTRAT)},
{"qringNF", Sy_bit(V_QRING), ~Sy_bit(V_QRING)},
{"warn", Sy_bit(V_ALLWARN), ~Sy_bit(V_ALLWARN)},
{"intersectSyz",Sy_bit(V_INTERSECT_SYZ), ~Sy_bit(V_INTERSECT_SYZ)},
{"intersectElim",Sy_bit(V_INTERSECT_ELIM), ~Sy_bit(V_INTERSECT_ELIM)},
{"pure_gb",Sy_bit(V_PURE_GB), ~Sy_bit(V_PURE_GB)},
/*special for "none" and also end marker for showOption:*/
{"ne", 0, 0 }
};
V_QRING
#define V_QRING
Definition options.h:42
V_DEF_RES
#define V_DEF_RES
Definition options.h:50
V_INTERSECT_SYZ
#define V_INTERSECT_SYZ
Definition options.h:69
V_SHOW_MEM
#define V_SHOW_MEM
Definition options.h:43
V_ALLWARN
#define V_ALLWARN
Definition options.h:67
V_READING
#define V_READING
Definition options.h:46
V_COEFSTRAT
#define V_COEFSTRAT
Definition options.h:61
V_ASSIGN_NONE
#define V_ASSIGN_NONE
Definition options.h:70
V_CONTENTSB
#define V_CONTENTSB
Definition options.h:56
V_DEBUG_LIB
#define V_DEBUG_LIB
Definition options.h:48
V_MODPSOLVSB
#define V_MODPSOLVSB
Definition options.h:58
V_LOAD_PROC
#define V_LOAD_PROC
Definition options.h:49
V_UPTORADICAL
#define V_UPTORADICAL
Definition options.h:59
V_YACC
#define V_YACC
Definition options.h:44
V_FINDMONOM
#define V_FINDMONOM
Definition options.h:60
V_CANCELUNIT
#define V_CANCELUNIT
Definition options.h:57
V_INTERSECT_ELIM
#define V_INTERSECT_ELIM
Definition options.h:68
V_PURE_GB
#define V_PURE_GB
Definition options.h:71
V_NSB
#define V_NSB
Definition options.h:55
V_LENGTH
#define V_LENGTH
Definition options.h:64
V_IMAP
#define V_IMAP
Definition options.h:53
V_PROMPT
#define V_PROMPT
Definition options.h:54
V_SHOW_USE
#define V_SHOW_USE
Definition options.h:52